Imports System.Net.Sockets
Imports System.Text.Encoding
Imports System.Threading

'Source:
'Most of this was adapted from Corrado Cavalli's original work - 
'http://www.codeworks.it/net/VBNetRs232.htm

Public Class Nsock
    Private MySocket As New UdpClient()
    Private GetSocket As UdpClient
    Private iLocalPort As Integer = 0
    Private MyState As SocketStates
    Private bcast As UDPb

    Public Event DataArrival(ByVal sData As String, ByVal bData As Byte(), ByVal sRemoteHost As String, ByVal nRemotePort As Integer)
    Private MyThread As New Thread(AddressOf GetData)

    Public Enum SocketStates
        NotBound = 0
        Bound = 1
    End Enum

    Public ReadOnly Property State() As SocketStates
        Get
            State = MyState
        End Get
    End Property

    Public Property LocalPort()
        Get
            LocalPort = iLocalPort
        End Get

        Set(ByVal Value)
            iLocalPort = Value
        End Set
    End Property

    Public Function SendText(ByVal sValue As String, ByVal sRemoteHost As String, ByVal sRemotePort As Integer)
        bcast = New UDPb(sRemoteHost, sRemotePort, sValue)
        bcast.SendMessage()
    End Function

    Public Function Bind(Optional ByVal nLocalPort1 As Integer = 0)
        If nLocalPort1 <> 0 Then iLocalPort = nLocalPort1
        If MyState = SocketStates.NotBound Then
            MyState = SocketStates.Bound
            MyThread.Start()
        End If
    End Function

    Public Function StopSocket()
        If MyState = SocketStates.Bound Then
            MyState = SocketStates.NotBound
        End If
        If Not GetSocket Is Nothing Then
            GetSocket.Close()
        End If
    End Function

    Private Sub GetData()
        Dim RemoteComputer As New System.Net.IPEndPoint(System.Net.IPAddress.Any, 0)
        Dim MyByte() As Byte
        Dim MyText As String

        Try
            GetSocket = New UdpClient(iLocalPort)
        Catch ex As SocketException
            MessageBox.Show("Could not open Network Port! " & ex.ToString())
        End Try

        Do While MyState = SocketStates.Bound
            Try
                MyByte = GetSocket.Receive(RemoteComputer)
                MyText = ASCII.GetString(MyByte)
                RaiseEvent DataArrival(MyText, MyByte, RemoteComputer.Address.ToString, RemoteComputer.Port)
            Catch nex As NullReferenceException
                MyState = SocketStates.NotBound
            End Try
        Loop
    End Sub

    Public Sub close()
        MyThread.Abort()
        Me.StopSocket()
    End Sub

    Protected Overrides Sub Finalize()
        Me.StopSocket()
        MyBase.Finalize()
    End Sub
End Class

